unit Unit2;

interface

uses
  Classes, SysUtils, IWAppForm, IWApplication, IWColor, IWTypes, IWCompButton,
  IWCompEdit, Controls, IWVCLBaseControl, IWBaseControl, IWBaseHTMLControl,
  IWControl, IWCompLabel,
  uFormPolicy, uIWFormPolicyDlg, uFormPolicyDesigner,
  uIWSecDlg, uSecDlgForm,
  uSecControl, DB, DBTables, ADODB, IWDBStdCtrls, uIWChangePasswordDlg,
  IWVCLComponent, IWBaseLayoutComponent, IWBaseContainerLayout,
  IWContainerLayout, IWTemplateProcessorHTML, Forms, IWVCLBaseContainer,
  IWContainer, IWHTMLContainer, IWHTML40Container, IWRegion,
  IWCompText
  {IW121}
  {Uncomment the line below when using IntraWeb 12.1 or higher}
  //, IWCompExtCtrls
  {Pre IW121}
  {Uncomment the line below when using IntraWeb 12.0 or lower}
  , IWExtCtrls
  ;

type
  TIWForm2 = class(TIWAppForm)
    lbName: TIWLabel;
    edName: TIWEdit;
    lbPassword: TIWLabel;
    edPass: TIWEdit;
    btLogin: TIWButton;
    btFormPolicy: TIWButton;
    dsADOPermissions: TDataSource;
    ADOPermissions: TADOTable;
    ADOConnection1: TADOConnection;
    btPermissions: TIWButton;
    uilSecurityManager1: TuilSecurityManager;
    uilFormPolicy1: TuilFormPolicy;
    uilFormPolicyDlg1: TuilIWFormPolicyDlg;
    uilSecurityDlg1: TuilIWSecurityDlg;
    dsUsers: TDataSource;
    ADOTableUsers: TADOTable;
    dsUserAccess: TDataSource;
    ADOTableUserAccess: TADOTable;
    ADOTableGroups: TADOTable;
    dsGroups: TDataSource;
    ADOGroupAccess: TADOTable;
    dsGroupAccess: TDataSource;
    ADOGroupMembers: TADOTable;
    dsGroupMembers: TDataSource;
    lbStatus: TIWLabel;
    btLogout: TIWButton;
    uilChangePasswordDlg1: TuilIWChangePasswordDlg;
    btChangePassword: TIWButton;
    lbTitle: TIWLabel;
    tCustomers: TTable;
    dsCustomers: TDataSource;
    IWRegion2: TIWRegion;
    lbCaption: TIWLabel;
    IWRegion1: TIWRegion;
    lbHelp: TIWLabel;
    IWLabel1: TIWLabel;
    IWLabel2: TIWLabel;
    IWLabel3: TIWLabel;
    IWImageFile1: TIWImageFile;
    edPhone: TIWDBEdit;
    lbPhone: TIWLabel;
    lbCountry: TIWLabel;
    edCountry: TIWDBEdit;
    edContact: TIWDBEdit;
    lbContact: TIWLabel;
    lbCompany: TIWLabel;
    IWDBNavigator1: TIWDBNavigator;
    edCompany: TIWDBEdit;
    IWRegion3: TIWRegion;
    IWText1: TIWText;
    IWLabel4: TIWLabel;
    procedure IWAppFormCreate(Sender: TObject);
    procedure btFormPolicyAsyncClick(Sender: TObject; EventParams: TStringList);
    procedure btPermissionsAsyncClick(Sender: TObject; EventParams: TStringList);
    procedure btLoginClick(Sender: TObject);
    procedure btLogoutClick(Sender: TObject);
    procedure btChangePasswordAsyncClick(Sender: TObject; EventParams: TStringList);
    procedure edNameAsyncKeyUp(Sender: TObject; EventParams: TStringList);
    procedure uilFormPolicy1CustomSecure(Sender: TObject;
      AComponent: TComponent; Secure: Boolean);
  public
  end;

implementation

{$R *.dfm}


procedure TIWForm2.btLogoutClick(Sender: TObject);
begin
  uilSecurityManager1.Logout;
  lbStatus.Text := 'logged out';
  edName.Text := EmptyStr;
  edPass.Text := EmptyStr;
  btLogout.Enabled := false;
  btLogin.Enabled := false;
end;

procedure TIWForm2.IWAppFormCreate(Sender: TObject);
var
   APath : string;
begin
   // Get the path to the data
   APath := ExtractFilePath(Application.ExeName);
   if APath[Length(APath)] <> '\' then
      APath := APath + '\';
   APath := APath + 'Data';

   btLogin.Enabled := false;
   btLogout.Enabled := false;

   IWImageFile1.ImageFile.URL := '/files/members_gray_48.png';

   ADOConnection1.Close;
   ADOConnection1.ConnectionString := 'Provider=Microsoft.Jet.OLEDB.4.0;User ID=Admin;Data Source='+ APath + '\security.mdb;Mode=Share Deny None;Extended Properties="";Jet OLEDB:System database="";Jet OLEDB:Registry Path="";Jet OLEDB:Database Password="";Jet OLEDB:Engine Type=5;'
     + 'Jet OLEDB:Database Locking Mode=1;Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Global Bulk Transactions=1;Jet OLEDB:'
     + 'New Database Password="";Jet OLEDB:Create System Database=False;Jet OLEDB:Encrypt Database=False;'
     + 'Jet OLEDB:Don''t Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;Jet OLEDB:SFP=False';

   ADOConnection1.Open;

   ADOPermissions.Active := true;
end;

procedure TIWForm2.uilFormPolicy1CustomSecure(Sender: TObject;
  AComponent: TComponent; Secure: Boolean);
begin
  if AComponent = IWImageFile1 then
  begin
     if Secure then
     begin
       if uilSecurityManager1.LoggedIn then
         IWImageFile1.ImageFile.URL := '/files/members_48.png'
       else
         IWImageFile1.ImageFile.URL := '/files/members_gray_48.png';
     end
  end;
end;

procedure TIWForm2.btLoginClick(Sender: TObject);
begin
  if edName.Text <> EmptyStr then
  begin
    ADOTableUserAccess.Open;
    ADOTableGroups.Open;
    ADOGroupMembers.Open;
    ADOGroupAccess.Open;

    if uilSecurityManager1.Login(edName.Text, edPass.Text) then
    begin
       lbStatus.Text := 'logged in';
       btLogout.Enabled := true;
       btLogin.Enabled := false;
    end
    else
       lbStatus.Text := 'wrong password or username';
  end;
end;

procedure TIWForm2.btChangePasswordAsyncClick(Sender: TObject;
  EventParams: TStringList);
begin
  uilChangePasswordDlg1.Execute;
end;

procedure TIWForm2.btFormPolicyAsyncClick(Sender: TObject;
  EventParams: TStringList);
begin
  uilFormPolicyDlg1.Execute;
end;

procedure TIWForm2.btPermissionsAsyncClick(Sender: TObject;
  EventParams: TStringList);
begin
  uilSecurityDlg1.Execute;
end;

procedure TIWForm2.edNameAsyncKeyUp(Sender: TObject; EventParams: TStringList);
begin
  if edName.Text <> EmptyStr then  
    btLogin.Enabled := true
  else
    btLogin.Enabled := false;
end;

initialization
  TIWForm2.SetAsMainForm;

end.
