// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'uBindary.pas' rev: 6.00

#ifndef uBindaryHPP
#define uBindaryHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Variants.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <DB.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Ubindary
{
//-- type declarations -------------------------------------------------------
typedef void __fastcall (__closure *TuilEncryptEvent)(System::TObject* Sender, AnsiString PlainText, AnsiString &EncryptedText);

class DELPHICLASS TuilBindary;
class PASCALIMPLEMENTATION TuilBindary : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	Db::TDataSource* FDataSource;
	AnsiString FKeyField;
	AnsiString FPassword;
	Classes::TComponent* FSecurityManager;
	TuilEncryptEvent FOnEncrypt;
	
protected:
	void __fastcall SetDataSource(Db::TDataSource* newValue);
	__property Classes::TComponent* SecurityManager = {read=FSecurityManager, write=FSecurityManager};
	
public:
	__fastcall virtual TuilBindary(Classes::TComponent* ASecurityManager);
	__fastcall virtual ~TuilBindary(void);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation);
	virtual Db::TField* __fastcall FieldByName(AnsiString FieldName);
	virtual bool __fastcall Locate(const Variant &KeyValues);
	virtual AnsiString __fastcall Encrypt(const AnsiString S);
	__property AnsiString KeyField = {read=FKeyField, write=FKeyField};
	
__published:
	__property Db::TDataSource* DataSource = {read=FDataSource, write=SetDataSource};
	__property AnsiString Password = {read=FPassword, write=FPassword};
	__property TuilEncryptEvent OnEncrypt = {read=FOnEncrypt, write=FOnEncrypt};
};


class DELPHICLASS TuilAccessBindary;
class PASCALIMPLEMENTATION TuilAccessBindary : public TuilBindary 
{
	typedef TuilBindary inherited;
	
protected:
	AnsiString __fastcall GetPermissionField();
	void __fastcall SetPermissionField(AnsiString newValue);
	
public:
	__fastcall virtual TuilAccessBindary(Classes::TComponent* ASecurityManager);
	virtual bool __fastcall HasAccess(AnsiString Permission);
	virtual bool __fastcall AddAccess(AnsiString Permission);
	virtual bool __fastcall RemoveAccess(AnsiString Permission);
	
__published:
	__property AnsiString PermissionField = {read=GetPermissionField, write=SetPermissionField};
public:
	#pragma option push -w-inl
	/* TuilBindary.Destroy */ inline __fastcall virtual ~TuilAccessBindary(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TuilPermissionStorage { psForm, psTable };
#pragma option pop

class DELPHICLASS TuilPermissionBindary;
class PASCALIMPLEMENTATION TuilPermissionBindary : public TuilAccessBindary 
{
	typedef TuilAccessBindary inherited;
	
private:
	AnsiString FItemField;
	AnsiString FActionField;
	TuilPermissionStorage FStorage;
	AnsiString FFormName;
	AnsiString FFormNameField;
	
public:
	virtual bool __fastcall HasAccess(AnsiString Permission);
	virtual bool __fastcall AddPermission(AnsiString Permission, AnsiString Items, AnsiString FormName, int Action);
	virtual bool __fastcall UpdatePermission(AnsiString Permission, AnsiString Items, AnsiString FormName, int Action);
	__property AnsiString FormName = {read=FFormName, write=FFormName};
	
__published:
	__property AnsiString ActionField = {read=FActionField, write=FActionField};
	__property AnsiString ItemField = {read=FItemField, write=FItemField};
	__property AnsiString FormNameField = {read=FFormNameField, write=FFormNameField};
	__property TuilPermissionStorage Storage = {read=FStorage, write=FStorage, nodefault};
public:
	#pragma option push -w-inl
	/* TuilAccessBindary.Create */ inline __fastcall virtual TuilPermissionBindary(Classes::TComponent* ASecurityManager) : TuilAccessBindary(ASecurityManager) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TuilBindary.Destroy */ inline __fastcall virtual ~TuilPermissionBindary(void) { }
	#pragma option pop
	
};


class DELPHICLASS TuilUserAccessBindary;
class PASCALIMPLEMENTATION TuilUserAccessBindary : public TuilAccessBindary 
{
	typedef TuilAccessBindary inherited;
	
private:
	AnsiString FUserNameField;
	
public:
	__fastcall virtual TuilUserAccessBindary(Classes::TComponent* ASecurityManager);
	virtual bool __fastcall AddAccess(AnsiString Permission);
	virtual bool __fastcall AddUserAccess(AnsiString UserName, AnsiString Permission);
	virtual bool __fastcall RemoveUserAccess(AnsiString UserName, AnsiString Permission);
	virtual bool __fastcall HasUserAccess(AnsiString UserName, AnsiString Permission);
	
__published:
	__property AnsiString UserNameField = {read=FUserNameField, write=FUserNameField};
public:
	#pragma option push -w-inl
	/* TuilBindary.Destroy */ inline __fastcall virtual ~TuilUserAccessBindary(void) { }
	#pragma option pop
	
};


class DELPHICLASS TuilGroupAccessBindary;
class PASCALIMPLEMENTATION TuilGroupAccessBindary : public TuilAccessBindary 
{
	typedef TuilAccessBindary inherited;
	
private:
	AnsiString FGroupNameField;
	
public:
	__fastcall virtual TuilGroupAccessBindary(Classes::TComponent* ASecurityManager);
	virtual bool __fastcall AddAccess(AnsiString Permission);
	virtual bool __fastcall AddGroupAccess(AnsiString Group, AnsiString Permission);
	virtual bool __fastcall RemoveGroupAccess(AnsiString Group, AnsiString Permission);
	virtual bool __fastcall HasGroupAccess(AnsiString Group, AnsiString Permission);
	
__published:
	__property AnsiString GroupNameField = {read=FGroupNameField, write=FGroupNameField};
public:
	#pragma option push -w-inl
	/* TuilBindary.Destroy */ inline __fastcall virtual ~TuilGroupAccessBindary(void) { }
	#pragma option pop
	
};


class DELPHICLASS TuilGroupMembershipBindary;
class PASCALIMPLEMENTATION TuilGroupMembershipBindary : public TuilBindary 
{
	typedef TuilBindary inherited;
	
private:
	AnsiString FUserNameField;
	
protected:
	AnsiString __fastcall GetGroupNameField();
	void __fastcall SetGroupNameField(AnsiString newValue);
	
public:
	__fastcall virtual TuilGroupMembershipBindary(Classes::TComponent* ASecurityManager);
	virtual bool __fastcall Locate(const Variant &KeyValues);
	virtual bool __fastcall AddUserToGroup(AnsiString Username, AnsiString GroupName);
	virtual bool __fastcall RemoveUserFromGroup(AnsiString Username, AnsiString GroupName);
	
__published:
	__property AnsiString GroupNameField = {read=GetGroupNameField, write=SetGroupNameField};
	__property AnsiString UserNameField = {read=FUserNameField, write=FUserNameField};
public:
	#pragma option push -w-inl
	/* TuilBindary.Destroy */ inline __fastcall virtual ~TuilGroupMembershipBindary(void) { }
	#pragma option pop
	
};


class DELPHICLASS TuilUserBindary;
class PASCALIMPLEMENTATION TuilUserBindary : public TuilBindary 
{
	typedef TuilBindary inherited;
	
private:
	bool FCaseSensUsername;
	bool FCaseSensPassword;
	AnsiString FFullNameField;
	AnsiString FPasswordField;
	AnsiString FAccessCountField;
	AnsiString FCreatedDateField;
	AnsiString FCreatedTimeField;
	AnsiString FEnabledField;
	AnsiString FLastAccessField;
	AnsiString FLastAccessTimeField;
	TuilUserAccessBindary* FUserPermissions;
	
protected:
	AnsiString __fastcall GetUserNameField();
	void __fastcall SetUserNameField(AnsiString newValue);
	
public:
	virtual void __fastcall AddUser(void);
	virtual void __fastcall UpdateLogin(void);
	__fastcall virtual TuilUserBindary(Classes::TComponent* ASecurityManager);
	__fastcall virtual ~TuilUserBindary(void);
	void __fastcall ChangePassword(AnsiString NewPassword);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation);
	virtual bool __fastcall Locate(const Variant &KeyValues);
	
__published:
	__property bool CaseSensitiveUsername = {read=FCaseSensUsername, write=FCaseSensUsername, default=0};
	__property bool CaseSensitivePassword = {read=FCaseSensPassword, write=FCaseSensPassword, default=1};
	__property AnsiString UserNameField = {read=GetUserNameField, write=SetUserNameField};
	__property AnsiString FullNameField = {read=FFullNameField, write=FFullNameField};
	__property AnsiString PasswordField = {read=FPasswordField, write=FPasswordField};
	__property AnsiString AccessCountField = {read=FAccessCountField, write=FAccessCountField};
	__property AnsiString CreatedDateField = {read=FCreatedDateField, write=FCreatedDateField};
	__property AnsiString CreatedTimeField = {read=FCreatedTimeField, write=FCreatedTimeField};
	__property AnsiString EnabledField = {read=FEnabledField, write=FEnabledField};
	__property AnsiString LastAccessField = {read=FLastAccessField, write=FLastAccessField};
	__property AnsiString LastAccessTimeField = {read=FLastAccessTimeField, write=FLastAccessTimeField};
	__property TuilUserAccessBindary* UserPermissions = {read=FUserPermissions, write=FUserPermissions};
};


class DELPHICLASS TuilGroupBindary;
class PASCALIMPLEMENTATION TuilGroupBindary : public TuilBindary 
{
	typedef TuilBindary inherited;
	
private:
	AnsiString FGroupDescriptionField;
	TuilGroupAccessBindary* FGroupPermissions;
	TuilGroupMembershipBindary* FGroupMemBindary;
	
protected:
	AnsiString __fastcall GetGroupNameField();
	void __fastcall SetGroupNameField(AnsiString newValue);
	
public:
	__fastcall virtual TuilGroupBindary(Classes::TComponent* ASecurityManager);
	__fastcall virtual ~TuilGroupBindary(void);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation);
	
__published:
	__property AnsiString GroupNameField = {read=GetGroupNameField, write=SetGroupNameField};
	__property AnsiString GroupDescriptionField = {read=FGroupDescriptionField, write=FGroupDescriptionField};
	__property TuilGroupAccessBindary* GroupPermissions = {read=FGroupPermissions, write=FGroupPermissions};
	__property TuilGroupMembershipBindary* GroupMembershipBindary = {read=FGroupMemBindary, write=FGroupMemBindary};
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Ubindary */
using namespace Ubindary;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// uBindary
